# Tree Controller

Tools and systems for changing ages, types, colors, growth and seasonal behaviors for trees and wild bushes.

Improvements to plopping and brushing trees and wild bushes including: age choices (Plop fully grown trees), random rotation, and forest brushes.

Video Demo available on [YouTube](https://www.youtube.com/watch?v=YoyMliyWJQU)

## Dependencies
[Unified Icon Library](https://thunderstore.io/c/cities-skylines-ii/p/algernon/Unified_Icon_Library/)

[BepInExPack](https://thunderstore.io/c/cities-skylines-ii/p/BepInEx/BepInExPack/)

## Change Log
[Available on Github](https://github.com/yenyang/Tree_Controller_BepInEx/blob/master/CHANGELOG.md)

## Donations
If you want to say thank you with a donation you can do so on [Buy Me A Coffee](https://www.buymeacoffee.com/yenyang_mods).

## Translations
I am looking for volunteers to help translate the mod into the official languages. For those interested please go to [CrowdIn](https://crowdin.com/project/csl2-mod-water-features).
Sorry the link says water features, I accidently uploaded the wrong file to one of the projects so the URLs are swapped.
Current Localization Support: Spanish by Nyoko, German by Hendrix, Italian by Mazi, Brazilian Portuguese by Luiz Fernando de Paula, Partial Chinese Simplified by RilkeXS.

## Detailed Description:
Includes a tree controller tool that lets you change the age or types of existing trees and/or bushes on the following selections:
* Single Tree
* Whole Building or Net
* Radius
* Whole Map

Please note that changing types of trees for networks is not persistant and revert as soon as anything touches the network. 
You cannot change types of trees using 'Single Tree' nor 'Whole Building or Net'. Eventually I may remove the ability to alter types of trees with 'Radius' and 'Whole Map'.

For plopping trees and wild bushes this mod adds choice of age(s) and the option to enable random rotation.

For brushing vegetation this mod adds choice of age(s) for trees and wild bushes and sets of vegetation for forest brushes. Some pre-made sets are:
* Deciduous (Exluding Apple and Poplar)
* Evergreen (Pine and Spruce)
* Wild bushes 

### Custom sets
Hold Ctrl to select or unselect multiple types of trees using the toolbar menu. Then hold Ctrl and click the custom set button to save a custom set. Once a set has been saved, click the custom set button to select that set. Hold Ctrl while switching themes to maintain the custom set.

### Tree Growth
Includes the option to disable tree growth over the whole map but it excludes any trees within specialized lumber industry areas.

To set all trees to Adult and/or Elderly, Select: Landscaping -> Vegetation -> Change Age Tool -> Whole Map -> Select Age(s) -> Right click on the map. 

This mod doesn't automatically set street trees or trees in buildings to a specified age, but you can change them with the tool. This feature may be included later.

### Seasonal Effects
Includes the option to make deciduous trees use dead model during winter. The dead model is not scaled based on the actual age of the tree.
Deciduous tree growth is paused during winter. Specialized lumber industry areas are excluded from this feature.

Please note, you must either disable this option or press the 'Safely Remove Button' to remove the mod safely during winter.
During any other season the mod can be readily removed. If you do not enable this option the mod can be readily removed.

Includes the option to use and create custom seasonal foliage colors. You can assign RGB values in CSV files that will be created in a folder the first time you run the mod.
The folder is located at %AppData%...\LocalLow\Colossal Order\Cities Skylines II\ModsData\Mods_Yenyang_Tree_Controller\FoliageColorData\ .
Don't bother altering with the Alpha value at this time. Cultivated city bushes are not included in seasonal foliage colors, but I am interested in modding this aspect.

### Collaboration
Algernon and I have collaborated to allow for age selection using Line Tool Lite.

## Support
I will respond on the code modding channels on Cities: Skylines Modding Discord.

## Credits 
* yenyang - Mod Author
* Chameleon TBN - Testing, Feedback, Icons, and Logo
* Algernon - Help with UI, Cooperative Development and Code Sharing, Collaboration regarding line tool.
* T.D.W., Klyte45, krzychu124, and Quboid - Cooperative Development and Code Sharing
* Localization: Hendrix (German), Nyoko (Spanish), Mazi (Italian), Luiz Fernando de Paula (Brazilian Portuguese), RilkeXS (Chinese Simplified)
* Tigon Ologdring, code:witch - Testing, Feedback